/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.hl7model.messages.financialmanagement;

import cdac.medinfo.sdk.hl7282.baselibs.messages.Message;
import cdac.medinfo.sdk.hl7282.baselibs.segments.EVN;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PD1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PID;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PRT;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ROL;
import cdac.medinfo.sdk.hl7282.baselibs.segments.SFT;
import cdac.medinfo.sdk.hl7282.baselibs.segments.UAC;
import cdac.medinfo.sdk.hl7282.commoninterface.IGroup;
import cdac.medinfo.sdk.hl7282.commoninterface.ISegment;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageCode;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageStructure;
import cdac.medinfo.sdk.hl7282.utils.EnumSegments;
import cdac.medinfo.sdk.hl7282.utils.EnumTriggerEvent;
import cdac.medinfo.sdk.hl7282.utils.IMap;

/**
 * BAR_P05- Update Account (Event P05).
 * This event is use to sent when an existing account is being updated. 
 * <p>Represents a BAR_P05 message structure (see chapter 6.4.5). This structure contains the 
 * following elements: </p>
 * 0: MSH (Message Header segment) <b></b><br>
 * 1: SFT (Software Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 2: UAC (User Authentication Credential segment) <b>SINGLE_OPTIONAL</b><br>
 * 3: EVN (Event Type Segment)  <b>SINGLE_COMPULSARY</b><br>
 * 4: PID (Patient Identification Segment) <b>SINGLE_COMPULSARY</b><br>
 * 5: PD1 (Patient Additional Demographic) <b>SINGLE_OPTIONAL</b><br>
 * 6: PRT (Participation Segment) <b>MULTIPLE_OPTIONAL</b><br>
 * 7: ROL (Role) <b>MULTIPLE_OPTIONAL</b><br>
 * 8: VISIT (a Group of segments in BAR_P05 message) <b>MULTIPLE_COMPULSARY</b><br>
 * This class provides mechanism to validate message against HL7 v 2.8.2 standard.
 * The class provides accessors & mutators for the elements mentioned above.
 * These elements can be easily populated & populated values can be easily retrieved.
 * The class has validate method which validates Message against HL7 v 2.8.2 standard.
 *
 * <p>Following is the step to create message<br>
 * Before that, respective Message Source and Message Recipient to be set on Message Factory.</p>
 * <p>BAR_P05 objP05 = (BAR_P05)MessageFactory.createInstance().createSendSupportedMessage("BAR", "P05");</p>
 */
public final class BAR_P05 extends Message 
{


	/**
	 * Constructs the BAR_P05 message.
	 */
	BAR_P05(IMap objMessageMap)
	{
		super(objMessageMap, EnumMessageCode.BAR.getValue(), EnumTriggerEvent.P05.getValue(), EnumMessageStructure.BAR_P05.getValue());
	}

	/**
	 * Adds Software Segment(SFT) to this message.
	 * @param objSFT Specified Software Segment(SFT) to be added in this message
	 */
	public void addSoftwareSegment(SFT objSFT)
	{
		addSegment(EnumSegments.HL7_SEG_SFT, objSFT);
	}

	/**
	 * Adds collection of Software Segment(SFT) to this message.
	 * @param objSFTSegmentCollection Collection of Software Segments
	 */
	@SuppressWarnings("unchecked")
	public void addSoftwareSegment(ISingleCollection<SFT> objSFTSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection = objSFTSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_SFT, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Software Segments(SFT) present in this message.
	 * @return ISingleCollectioSFTnt> - Collection of Software Segments(SFT) 
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<SFT> getSoftwareSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_SFT);
		return (ISingleCollection<SFT>)objSegmentCollection;
	}

	/**
	 * Retrieves Event Type(EVN) segment present in this message
	 * @return EVN - the EVN Segment present in this message or null if unavailable.
	 */
	public EVN getEventTypeSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_EVN);
		if(objSingleCollection != null)
			return (EVN)objSingleCollection.elementAt(0);
		return null;
	}
	
	/**
	 * Retrieves User Authentication Credential(UAC) segment present in this message
	 * @return UAC - the User Authentication Credential Segment present in this message or null if unavailable. 
	 */
	public UAC getUserAuthenticationCredentialSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UAC);
		if(objSingleCollection != null)
			return (UAC)objSingleCollection.elementAt(0);
		return null;
	}
	
	/**
	 * Sets value of User Authentication Credential(UAC) segment  for this message, overwrites if already present.
	 * @param objUAC Specified UAC Segment
	 */
	public void setUserAuthenticationCredentialSegment(UAC objUAC)
	{
		setSegment(EnumSegments.HL7_SEG_UAC,objUAC);
	}
	
	
	/**
	 * Sets value of Event Type segment for this message,overwrites if already present.
	 * @param objEVN Specified EVN Segment 
	 */
	public void setEventTypeSegment(EVN objEVN)
	{
		setSegment(EnumSegments.HL7_SEG_EVN,objEVN);
	}

	/**
	 * Retrieves Patient Identification(PID) segment present in this message.
	 * @return PID - the Patient Identification Segment present in this message or null if unavailable.
	 */
	public PID getPatientIdentificationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PID);
		if(objSingleCollection != null)
			return (PID)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of PID segment for this message,overwrites if already present.
	 * @param objPID Specified PID Segment 
	 */
	public void setPatientIdentificationSegment(PID objPID)
	{
		setSegment(EnumSegments.HL7_SEG_PID,objPID);
	}

	/**
	 * Retrieves Additinal Demographics segment(PD1) present in this message.
	 * @return PD1 - the Additinal Demographics(PD1) Segment. present in this message or null if unavailable.
	 */
	public PD1 getAdditinalDemographicSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PD1);
		if(objSingleCollection != null)
			return (PD1)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Additinal Demographics segment(PD1) for this message,overwrites if already present.
	 * @param objPD1 Specified Additinal Demographics(PD1) Segment. 
	 */
	public void setAdditinalDemographicSegment(PD1 objPD1)
	{
		setSegment(EnumSegments.HL7_SEG_PD1,objPD1);
	}
	
	/**
	 * Retrieves Collection of Participation(PRT) Segment present in this message.
	 * @return ISingleCollection<PRT> - collection of Participation(PRT) Segment present in message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<PRT> getParticipationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_PRT);
		return (ISingleCollection<PRT>)objSegmentCollection;
	}
	
	/**
	 * Adds Participation(PRT) Segment to this message.
	 * @param objPRT Specified Participation(PRT) Segment to be added in this message.
	 */
	public void addParticipationSegment(PRT objPRT)
	{
		addSegment(EnumSegments.HL7_SEG_PRT, objPRT);
	}

	/**
	 * Adds collection of PArticipation(PRT) Segment to this message.
	 * @param objPRTSegmentCollection Collection of Participation Segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPaticipationSegments(ISingleCollection<PRT> objPRTSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection = objPRTSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_PRT, (ISingleCollection<ISegment>)objSegmentCollection);
	}


	/**
	 * Retrieves Collection of Role Segment(ROL) present in this message.
	 * @return ISingleCollection<ROL> - Collection of Role Segment(ROL) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ROL> getPatientIdentificationRoleSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION);
		return (ISingleCollection<ROL>)objSegmentCollection;
	}

	/**
	 * Adds Role(ROL) segment associated with Patient Identification.
	 * @param  objROL Specified  Role(ROL) segment associated with Patient Identification.
	 */
	public void addPatientIdentificationRoleSegment(ROL objROL)
	{
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION, objROL);
	}

	/**
	 * Adds collection of Role(ROL) segments associated with Patient Identification.
	 * @param objROLSegmentCollection - Collection of Role(ROL)segments associated with Patient Identification.
	 */
	@SuppressWarnings("unchecked")
	public void addPatientIdentificationRoleSegments(ISingleCollection<ROL> objROLSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection = objROLSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of VISIT GROUP present in this message.
	 * @return ISingleCollection<Group> - Collection of Visit Group present 
	 */
	public ISingleCollection<IGroup> getVisitGroups()
	{
		return getGroup(EnumSegments.HL7_GROUP_VISIT);
	}

	/**
	 * Adds Collection of VISIT GROUP to this message.
	 * @param objSingleCollection Specified  VISIT GROUP Collection.
	 */
	public void addVisitGroups(ISingleCollection<IGroup> objSingleCollection)
	{
		addGroup(EnumSegments.HL7_GROUP_VISIT, objSingleCollection);
	}

	/**
	 * Adds VISIT GROUP to this message.
	 * @param objGroup Specified VISIT GROUP. 
	 */
	public void addVisitGroup(IGroup objGroup)
	{
		addGroup(EnumSegments.HL7_GROUP_VISIT, objGroup);
	}
}